package de.tobiasvonmassow.kaffees_dual_ride.mixin;

import net.minecraft.class_1297;
import net.minecraft.class_1496;
import net.minecraft.class_243;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.LocalCapture;

@Mixin(class_1496.class)
public class Kaffees_Dual_Ride_Mixin {
	@Inject(at = @At(value = "TAIL"), method = "updatePassengerPosition(Lnet/minecraft/entity/Entity;)V", locals = LocalCapture.CAPTURE_FAILHARD)
	private void injected(class_1297 passenger, CallbackInfo ci) {
		// set passengerposition to the position of the horse
		int i = ((class_1496)(Object)this).method_5685().indexOf(passenger);
		// horizontal offset
		float horizontal_offset = (float)((((class_1496)(Object)this).method_31481() ? (double)0.01f : ((class_1496)(Object)this).method_5621()) + passenger.method_5678());
		// first passenger is offset by 0.2, second passenger is offset by -0.6
		float x_offset = i == 0 ? 0.2f : -0.6f;
		// rotate passengers with horse
		class_243 vec3d = new class_243(x_offset, 0.0, 0.0).method_1024(-((class_1496)(Object)this).method_36454() * ((float)Math.PI / 180) - 1.5707964f);
		passenger.method_5814(((class_1496)(Object)this).method_23317() + vec3d.field_1352,((class_1496)(Object)this).method_23318() + (double)horizontal_offset,((class_1496)(Object)this).method_23321() + vec3d.field_1350);
	}
}